import { HttpClient } from '@angular/common/http';
import { CachedRepoAspect, EntityFilter, QueryResult } from '@yukawa/chain-base-angular-domain';
import { MonoTypeOperatorFunction, Observable, Subject } from 'rxjs';
import { ConfigService } from '../config';
import { EntityKey } from './entity-repository';
import { InterceptedRepoAspectsRest } from './intercepted-repo-aspects-rest';
export declare class CachedRepoAspectRest<K extends EntityKey, E, F extends EntityFilter> extends InterceptedRepoAspectsRest<K, E, F> implements CachedRepoAspect<K, E, F> {
    private readonly cacheDelay;
    private readonly _filterCache;
    private readonly _idCache;
    private readonly _idCacheRefreshSubjects;
    private readonly _keyExtractor;
    constructor(http: HttpClient, configService: ConfigService, urlKey: string, keyExtractor: (entity: E) => K, cacheDelay?: number);
    query(filter: F): Observable<QueryResult<E>>;
    load(key: K): Observable<E>;
    update(entity: E): Observable<E>;
    merge(entity: E): Observable<E>;
    put(entity: E): Observable<E>;
    edit(entity: E): Observable<E>;
    refreshOp(entity: E): MonoTypeOperatorFunction<E>;
    refreshCaches(entity: E): Promise<void>;
    refresh(): void;
    getCachedEntityObservable(key: K): Observable<E>;
    getRefreshSubject(key: K): Subject<void>;
    refreshEntityCache(key: K): Promise<void>;
    refreshQueryCache(filter?: F | E): Promise<void>;
    removeQueryCache(filter: F): boolean;
    clearQueryCache(): void;
    clearIdCache(): void;
    protected findQueryCacheKey(filter: F): F;
    private refreshCache;
}
